<?php
/*=================================================
   charset=utf-8
   Project:	phpGedView
   File:	facts.da.php
   Author:	John Finlay
   Translation:	Arne Eckmann
   Comments:	Defines an array of GEDCOM codes and the danish name facts that they represent.
   Change Log:	8/5/02 - File Created
===================================================*/
# $Id: facts.da.php,v 1.12.2.2 2004/02/03 21:36:07 botak Exp $
if (preg_match("/facts\...\.php$/", $_SERVER["PHP_SELF"])>0) {
	print "You cannot access a language file directly.";
	exit;
}
// -- Define a fact array to map Gedcom tags with their danish values
$factarray["ABBR"] = "Forkortelse";
$factarray["ADDR"] = "Adresse";
$factarray["ADR1"] = "Adresse 1";
$factarray["ADR2"] = "Adresse 2";
$factarray["ADOP"] = "Adoption";
$factarray["AFN"]  = "Ancestral File Number (AFN)";
$factarray["AGE"]  = "Alder";
$factarray["AGNC"] = "Agentur";
$factarray["ALIA"] = "Alias";
$factarray["ANCE"] = "Forfædre";
$factarray["ANCI"] = "Ane forbindelse";
$factarray["ANUL"] = "Annullering";
$factarray["ASSO"] = "Associates";
$factarray["AUTH"] = "Forfatter";
$factarray["BAPL"] = "LDS Baptism";
$factarray["BAPM"] = "Dåb";
$factarray["BARM"] = "Bar Mitzvah";
$factarray["BASM"] = "Bas Mitzvah";
$factarray["BIRT"] = "Fødsel";
$factarray["BLES"] = "Velsignelse";
$factarray["BLOB"] = "Binær dataobjekt";
$factarray["BURI"] = "Begravelse";
$factarray["CALN"] = "Kaldenummer";
$factarray["CAST"] = "Kaste / Social status";
$factarray["CAUS"] = "Dødsårsag";
$factarray["CENS"] = "Folketælling";
$factarray["CHAN"] = "Seneste ændring";
$factarray["CHAR"] = "Karaktersæt";
$factarray["CHIL"] = "Barn";
$factarray["CHR"]  = "Barnedåb";
$factarray["CHRA"] = "Voksendåb";
$factarray["CITY"] = "By";
$factarray["CONF"] = "Konfirmation";
$factarray["CONL"] = "LDS Confirmation";
$factarray["COPR"] = "Ophavsret";
$factarray["CORP"] = "Corporation / Firma";
$factarray["CREM"] = "Kremering";
$factarray["CTRY"] = "Land";
$factarray["DATE"] = "Dato";
$factarray["DATA"] = "Data";
$factarray["DEAT"] = "Dødsfald";
$factarray["DESC"] = "Afstamning";
$factarray["DESI"] = "Efterkommer forbindelse";
$factarray["DEST"] = "Destination";
$factarray["DIV"]  = "Skilsmisse";
$factarray["DIVF"] = "Skilsmisebegæring";
$factarray["DSCR"] = "Beskrivelse";
$factarray["EDUC"] = "Uddannelse";
$factarray["EMIG"] = "Udvandring";
$factarray["ENDL"] = "LDS Endowment";
$factarray["ENGA"] = "Forlovelse";
$factarray["EVEN"] = "Begivenhed";
$factarray["FAM"]  = "Familie";
$factarray["FAMC"] = "Familie som barn";
$factarray["FAMF"] = "Familiefile";
$factarray["FAMS"] = "Familie som partner";
$factarray["FCOM"] = "Første kommunion";
$factarray["FILE"] = "Ekstern fil:";
$factarray["FORM"] = "Format:";
$factarray["GIVN"] = "Fornavn(e)";
$factarray["GRAD"] = "Graduering";
$factarray["IDNO"] = "Identifikationsnummer";
$factarray["IMMI"] = "Indvandring";
$factarray["LEGA"] = "Arving";
$factarray["MARB"] = "Lysning";
$factarray["MARC"] = "Ægteskabskontrakt";
$factarray["MARL"] = "Ægteskabsbrev";
$factarray["MARR"] = "Ægteskab";
$factarray["MARS"] = "Marriage Settlement";
$factarray["NAME"] = "Navn";
$factarray["NATI"] = "Nationalitet";
$factarray["NATU"] = "Naturalisering";
$factarray["NCHI"] = "Antal børn";
$factarray["NICK"] = "Øge/kæle -navn";
$factarray["NMR"]  = "Antal ægteskaber";
$factarray["NOTE"] = "Notat";
$factarray["NPFX"] = "Præfiks";
$factarray["NSFX"] = "Suffiks";
$factarray["OBJE"] = "Multimedia objekt";
$factarray["OCCU"] = "Erhverv";
$factarray["ORDI"] = "Ordinance";
$factarray["ORDN"] = "Ordination";
$factarray["PAGE"] = "Citations detaljer";
$factarray["PEDI"] = "Pedigree";
$factarray["PLAC"] = "Stednavn";
$factarray["PHON"] = "Tlf.";
$factarray["POST"] = "Postnummer";
$factarray["PROB"] = "Skifte";
$factarray["PROP"] = "Ejendom";
$factarray["PUBL"] = "Publikation";
$factarray["QUAY"] = "Datakvalitet";
$factarray["REPO"] = "Opbevaringssted";
$factarray["REFN"] = "Referencenummer";
$factarray["RELI"] = "Religion";
$factarray["RESI"] = "Bopæl";
$factarray["RESN"] = "Restriction";
$factarray["RETI"] = "Pensionering";
$factarray["RFN"]  = "Record fil nummer";
$factarray["RIN"]  = "Record ID nummer";
$factarray["ROLE"] = "Rolle";
$factarray["SEX"]  = "Køn";
$factarray["SLGC"] = "LDS Child Sealing";
$factarray["SLGS"] = "LDS Spouse Sealing";
$factarray["SOUR"] = "Kilde";
$factarray["SPFX"] = "Efternavns præfiks";
$factarray["SSN"]  = "Social Security Number";
$factarray["STAE"] = "State";
$factarray["STAT"] = "Status";
$factarray["SUBM"] = "Submitter";
$factarray["SUBN"] = "Submission";
$factarray["SURN"] = "Efternavn";
$factarray["TEMP"] = "Tempel";
$factarray["TEXT"] = "Tekst";
$factarray["TIME"] = "Time";
$factarray["TITL"] = "Titel";
$factarray["TYPE"] = "Type";
$factarray["WILL"] = "Testamente";
$factarray["_EMAIL"] = "E-mail adresse";
$factarray["EMAIL"] = "E-mail adresse";
$factarray["_TODO"] = "Mangler at blive gjort";
$factarray["_UID"] = "Universal Identifikator";

// These facts are specific to gedcom exports from Family Tree Maker
$factarray["_MDCL"] = "Helbred";
$factarray["_DEG"] = "Akademisk grad";
$factarray["_MILT"] = "Militærtjeneste";
$factarray["_SEPR"] = "Separeret";
$factarray["_DETS"] = "Samlevers død";
$factarray["CITN"] = "Statsborgerskab";
$factarray["_FA1"] = "Fact 1";
$factarray["_FA2"] = "Fact 2";
$factarray["_FA3"] = "Fact 3";
$factarray["_FA4"] = "Fact 4";
$factarray["_FA5"] = "Fact 5";
$factarray["_FA6"] = "Fact 6";
$factarray["_FA7"] = "Fact 7";
$factarray["_FA8"] = "Fact 8";
$factarray["_FA9"] = "Fact 9";
$factarray["_FA10"] = "Fact 10";
$factarray["_FA11"] = "Fact 11";
$factarray["_FA12"] = "Fact 12";
$factarray["_FA13"] = "Fact 13";
$factarray["_MREL"] = "Relation til moder";
$factarray["_FREL"] = "Relation til fader";
$factarray["_FA1"] = "Ægteskabs facts";
$factarray["_MSTAT"] = "Æ startstatus";
$factarray["_MEND"] = "Æ slutstatus";

// These facts are specific to gedcom exports from Brothers Keeper
// Other common customized facts
$factarray["_ADPF"] = "Adopteret af far";
$factarray["_ADPM"] = "Adopteret af mor";
$factarray["_AKAN"] = "Alias";
$factarray["_AKA"] = "Også kendt som";
$factarray["_MARN"] = "Tilgiftet navn";
$factarray["_SLDN"] = "Soldaternavn";
$factarray["_BRTM"] = "Brit mila";
$factarray["_CENN"] = "Navn i folketælling";
$factarray["_SHON"] = "Kort navn";
$factarray["_INDN"] = "Indiansk navn";
$factarray["_HEBN"] = "Hebraisk navn";
$factarray["_FARN"] = "Gårdnavn";
$factarray["_BIRN"] = "Fødenavn";
$factarray["_FKAN"] = "Formelt kendt som";
$factarray["_CURN"] = "Brugsnavn";
$factarray["_OTHN"] = "Andet navn";
$factarray["_ADPN"] = "Adoptivnavn";
$factarray["_EYEC"] = "Øjenfarve";
$factarray["_WEIG"] = "Vægt";
$factarray["_YART"] = "Yartzeit";
$factarray["_NMR"] = "Ugift";
$factarray["_COML"] = "Samlevende";
$factarray["_MILI"] = "Militærtjeneste";
$factarray["_NMR "] = "Ugift";
$factarray["_NLIV"] = "Lever ikke";
$factarray["_HAIR"] = "Hårfarve";
$factarray["_HEIG"] = "Højde";
$factarray["_INTE"] = "Interneret";
$factarray["_MARI"] = "Marriage intention";
$factarray["_MBON"] = "Marriage bond";
$factarray["_MEDC"] = "Helbred";
$factarray["_FNRL"] = "Bisættelse";
$factarray["_NMAR"] = "Aldrig gift";
$factarray["_PRMN"] = "Permanent nummer";

if (file_exists($PGV_BASE_DIRECTORY . "languages/facts.da.extra.php")) require $PGV_BASE_DIRECTORY . "languages/facts.da.extra.php";

?>