<?php
/*=================================================
   charset=utf-8
   Project:	phpGedView
   File:	facts.es-ar.php
   Author:	John Finlay
   Comments:	Defines an array of GEDCOM codes and the argentinian spanish name facts that they represent.
   Change Log:	8/5/02 - File Created
===================================================*/
# $Id: facts.es-ar.php,v 1.1.2.2 2004/01/29 15:32:18 yalnifj Exp $
if (preg_match("/facts\..+\.php$/", $_SERVER["PHP_SELF"])>0) {
	print "You cannot access a language file directly.";
	exit;
}
// -- Define a fact array to map Gedcom tags with their argentinian spanish values
$factarray["ABBR"] = "Abreviatura";
$factarray["ADDR"] = "Direcci&oacute;n";
$factarray["ADR1"] = "Direcci&oacute;n 1";
$factarray["ADR2"] = "Direcci&oacute;n 2";
$factarray["ADOP"] = "Adopci&oacute;n";
$factarray["AFN"]  = "Ancestral File Number (AFN)";
$factarray["AGE"]  = "Edad";
$factarray["AGNC"] = "Agencia";
$factarray["ALIA"] = "Alias";
$factarray["ANCE"] = "Antepasados";
$factarray["ANCI"] = "Antepasados de Inter&eacute;s";
$factarray["ANUL"] = "Anulaci&oacute;n";
$factarray["ASSO"] = "Asociados";
$factarray["AUTH"] = "Autor";
$factarray["BAPL"] = "Bautismo LDS";
$factarray["BAPM"] = "Bautismo";
$factarray["BARM"] = "Bar Mitzvah";
$factarray["BASM"] = "Bas Mitzvah";
$factarray["BIRT"] = "Nacimiento:<br>";
$factarray["BLES"] = "Bendici&oacute;n";
$factarray["BLOB"] = "Objeto de Datos Binarios";
$factarray["BURI"] = "Entierro";
$factarray["CALN"] = "Referencia";
$factarray["CAST"] = "Estatus Social";
$factarray["CAUS"] = "Causa de la muerte";
$factarray["CENS"] = "Censo";
$factarray["CHAN"] = "&Uacute;ltimo cambio";
$factarray["CHAR"] = "Juego de Caracteres";
$factarray["CHIL"] = "Hijo";
$factarray["CHR"]  = "Bautismo";
$factarray["CHRA"] = "Bautismo en edad adulta";
$factarray["CITY"] = "Ciudad";
$factarray["CONF"] = "Confirmaci&oacute;n";
$factarray["CONL"] = "LDS Confirmaci&oacute;n";
$factarray["COPR"] = "Copyright";
$factarray["CORP"] = "Corporaci&oacute;n / Compa&ntilde;&iacute;a";
$factarray["CREM"] = "Cremaci&oacute;n";
$factarray["CTRY"] = "Pa&iacute;s";
$factarray["DATA"] = "Datos";
$factarray["DATE"] = "Fecha";
$factarray["DEAT"] = "Defunci&oacute;n";
$factarray["DESC"] = "Descendientes";
$factarray["DESI"] = "Descendientes de Inter&eacute;s";
$factarray["DEST"] = "Destino";
$factarray["DIV"]  = "Divorcio";
$factarray["DIVF"] = "Divorcio Archivado";
$factarray["DSCR"] = "Descripci&oacute;n";
$factarray["EDUC"] = "Educaci&oacute;n";
$factarray["EMIG"] = "Emigraci&oacute;n";
$factarray["ENDL"] = "LDS Dotaci&oacute;n";
$factarray["ENGA"] = "Compromiso matrimonio";
$factarray["EVEN"] = "Evento";
$factarray["FAM"]  = "Familia";
$factarray["FAMC"] = "Familia como hijo";
$factarray["FAMF"] = "Fichero Familia";
$factarray["FAMS"] = "Familia como c&oacute;nyuge";
$factarray["FCOM"] = "Primera Communi&oacute;n";
$factarray["FILE"] = "Fichero Externo";
$factarray["FORM"] = "Formato:";
$factarray["GIVN"] = "Habitualmente nombrado";
$factarray["GRAD"] = "Graduaci&oacute;n";
$factarray["IDNO"] = "Numero de Identificaci&oacute;n";
$factarray["IMMI"] = "Immigraci&oacute;n";
$factarray["LEGA"] = "Herencia";
$factarray["MARB"] = "Amonestaciones";
$factarray["MARC"] = "Contrato Matrimonial";
$factarray["MARL"] = "Licencia Matrimonial";
$factarray["MARR"] = "Matrimonio";
$factarray["MARS"] = "Marriage Settlement";
$factarray["NAME"] = "Nombre";
$factarray["NATI"] = "Nacionalidad";
$factarray["NATU"] = "Natural";
$factarray["NCHI"] = "N&uacute;mero de Hijos";
$factarray["NICK"] = "Apodo";
$factarray["NMR"]  = "N&uacute;mero de matrimonios";
$factarray["NOTE"] = "Nota";
$factarray["NPFX"] = "Prefijo";
$factarray["NSFX"] = "Sufijo";
$factarray["OBJE"] = "Objeto Multimedia";
$factarray["OCCU"] = "Ocupaci&oacute;n";
$factarray["ORDI"] = "Ordenanza";
$factarray["ORDN"] = "Ordenaci&oacute;n";
$factarray["PAGE"] = "Detalles";
$factarray["PEDI"] = "Antepasados";
$factarray["PLAC"] = "Lugar";
$factarray["PHON"] = "Telef.";
$factarray["POST"] = "C&oacute;digo Postal";
$factarray["PROB"] = "Certificado Testamento";
$factarray["PROP"] = "Propiedad";
$factarray["PUBL"] = "Publicaci&oacute;n";
$factarray["QUAY"] = "Calidad de los datos";
$factarray["REPO"] = "Archivo";
$factarray["REFN"] = "N&uacute;mero Ref";
$factarray["RELI"] = "Religi&oacute;n";
$factarray["RESI"] = "Residencia";
$factarray["RESN"] = "Restricci&oacute;n";
$factarray["RETI"] = "Jubilaci&oacute;n";
$factarray["RFN"]  = "N&uacute;mero de archivo del registro";
$factarray["RIN"]  = "N&uacute;mero ID";
$factarray["ROLE"] = "Rol";
$factarray["SEX"]  = "Sexo";
$factarray["SLGC"] = "LDS Sellam. Hijo";
$factarray["SLGS"] = "LDS Sellam. C&oacute;nyuge";
$factarray["SOUR"] = "Fuente";
$factarray["SPFX"] = "Prefijo del Apellido";
$factarray["SSN"]  = "N&uacute;mero Seguridad Social";
$factarray["STAE"] = "Estado";
$factarray["STAT"] = "Estatus";
$factarray["SUBM"] = "Remitente";
$factarray["SUBN"] = "Env&iacute;o";
$factarray["SURN"] = "Apellido";
$factarray["TEMP"] = "Templo";
$factarray["TEXT"] = "Texto";
$factarray["TIME"] = "Tiempo";
$factarray["TITL"] = "T&iacute;tulo";
$factarray["WILL"] = "Testamento";
$factarray["TYPE"] = "Tipo";
$factarray["_EMAIL"] = "Email";
$factarray["EMAIL"] = "Direcci&oacute;n de correo electr&oacute;nico";
$factarray["_TODO"]  = "Hacer Item";
$factarray["_UID"]   = "Identificador Universal";

// These facts are specific to gedcom exports from Family Tree Maker
$factarray["_MDCL"] = "M&eacute;dico";
$factarray["_DEG"]  = "Grado";
$factarray["_MILT"] = "Servicio Militar";
$factarray["_SEPR"] = "Separado";
$factarray["_DETS"] = "Fallecimiento de un c&oacute;nyuge";
$factarray["CITN"]  = "Ciudadan&iacute;a";
$factarray["_EYEC"]	= "Color de ojos";
$factarray["_HAIR"]	= "Color de cabello";
$factarray["_HEIG"]	= "Altura";
$factarray["_MARI"]	= "Intenci&oacute;n de casamiento";
$factarray["_MEDC"]	= "Condici&oacute;n m&eacute;dica";
$factarray["_MILI"]	= "Militar";
$factarray["_NMR "]	= "Soltero";
$factarray["_NLIV"]	= "Fallecido";
$factarray["_NMAR"]	= "Nunca se cas&oacute";
$factarray["_WEIG"]	= "Peso";

// Other common customized facts
$factarray["_ADPF"]	= "Adoptado por el padre";
$factarray["_ADPM"]	= "Adoptado por la madre";
$factarray["_AKAN"]	= "Tambi&eacute;n conocido como";

if (file_exists($PGV_BASE_DIRECTORY . "languages/facts.es-ar.extra.php")) require $PGV_BASE_DIRECTORY . "languages/facts.es-ar.extra.php";

?>
