<?php
/*=================================================
   charset=utf-8
   Project:	phpGedView
   File:	facts.he.php
   Author:	John Finlay
   Developer:	KosherJava
   Comments:	Defines an array of GEDCOM codes and the Hebrew name facts that they represent.
===================================================*/
# $Id: facts.he.php,v 1.10.2.1 2004/01/26 22:33:37 yalnifj Exp $
if (preg_match("/facts\...\.php$/", $_SERVER["PHP_SELF"])>0) {
	print "You cannot access a language file directly.";
	exit;
}
// -- Define a fact array to map Gedcom tags with their hebrew values
$factarray["ABBR"] = "קיצור";
$factarray["ADDR"] = "כתובת";
$factarray["ADR1"] = "כתובת 1";
$factarray["ADR2"] = "כתובת 2";
$factarray["ADOP"]	= "אמוץ";
$factarray["AGE"] = "גיל";
$factarray["AGNC"]	= "סוכנות";
$factarray["ALIA"] = "שם נרדף";
$factarray["AUTH"] = "מחבר";
$factarray["BARM"] = "בר מצוה";
$factarray["BASM"] = "בת מצוה";
$factarray["BIRT"] = "לידה";
$factarray["BLOB"] = "אובייקט נתונים בינארי";
$factarray["BURI"] = "קבורה";
$factarray["CAUS"]	= "גרם מות";
$factarray["CENS"]	= "מפקד אכלוסין";
$factarray["CHAN"] = "שנוי אחרון";
$factarray["CHAR"] = "ערכת תווים";
$factarray["CHIL"] = "ילד/ה";
$factarray["CITY"] = "עיר";
$factarray["COPR"] = "זכויות יוצרים";
$factarray["CTRY"] = "מדינה";
$factarray["DATA"] = "נתונים";
$factarray["DATE"] = "תאריך";
$factarray["DEAT"] = "פטירה";
$factarray["DESC"] = "תולדות";
$factarray["DEST"] = "יעד";
$factarray["DIV"] = "גרושין";
$factarray["EDUC"]	= "חנוך";
$factarray["DSCR"] = "תיאור";
$factarray["EMIG"] = "יציאה";
$factarray["ENGA"] = "ארוסין";
$factarray["EVEN"] = "אירוע";
$factarray["FAM"] = "משפחה";
$factarray["FAMF"] = "קובץ משפחה";
$factarray["FILE"] = "קובץ  חיצוני:";
$factarray["FORM"] = "תבנית:";
$factarray["GIVN"] = "שם פרטי\\שמות פרטיים";
$factarray["GRAD"] = "סיום";
$factarray["LEGA"]	= "יורש";
$factarray["IDNO"] = "קוד זיהוי";
$factarray["IMMI"] = "הגירה";
$factarray["MARC"] = "כתובה";
$factarray["MARL"] = "רשיון נשואין";
$factarray["NCHI"] = "מספר ילדים";
$factarray["NICK"] = "כנוי";
$factarray["NMR"] = "מספר נשואין";
$factarray["PLAC"] = "מקום";
$factarray["PHON"] = "טלפון";
$factarray["PUBL"]	= "הוצאה לאור";
$factarray["RELI"]	= "דת";
$factarray["ROLE"]	= "תפקיד";
$factarray["RESN"]	= "הגבלה";
$factarray["RESI"]	= "מגורים";
$factarray["REPO"]	= "מקום אחסון";
$factarray["STAT"]	= "סטטוס";
$factarray["SUBM"]	= "מגיש";
$factarray["SUBN"]	= "הגשה";
$factarray["PROP"]	= "נכס";
$factarray["PROB"]	= "אישור צוואה";
$factarray["SOUR"] = "מקור";
$factarray["SURN"] = "שם משפחה";
$factarray["TEXT"] = "טקסט";
$factarray["TIME"] = "זמן";
$factarray["TITL"]	= "כותרת";
$factarray["_MDCL"]	= "רפואי";
$factarray["CITN"]	= "אזרחות";
$factarray["TYPE"] = "סוג";
$factarray["WILL"]	= "צואה";
$factarray["_MILT"] = "שרות צבא";
$factarray["SEX"] = "מין";
$factarray["NAME"] = "שם";
$factarray["MARS"]	= "הסדר נשואין";
$factarray["NATI"] = "לאם";
$factarray["NATU"] = "זכות אזרח";
$factarray["MARR"] = "נשואין";
$factarray["PAGE"]	= "פרטי צטוט";
$factarray["OCCU"]	= "מקצוע";
$factarray["NOTE"] = "הערה";
$factarray["NSFX"] = "צירוף סופי";
$factarray["NPFX"] = "צירוף ראשי";
$factarray["OBJE"] = "אובייקט מולטימדיה";
$factarray["PEDI"] = "יחוס";

// These facts are specific to gedcom exports from Family Tree Maker
$factarray["_MDCL"]	= "Medical";

// Other common customized facts
$factarray["_ADPF"] = "Adopted by father";
$factarray["_BRTM"] = "ברית מילה";
$factarray["_FNRL"]	= "הלויה";
$factarray["_MILI"] = "צבא";
$factarray["_NLIV"] = "לא בחיים";
$factarray["_WEIG"] = "משקל";


if (file_exists($PGV_BASE_DIRECTORY . "languages/facts.he.extra.php")) require $PGV_BASE_DIRECTORY . "languages/facts.he.extra.php";

?>