<?php
/*=================================================
   charset=utf-8
   File:	facts.nl.php
   Author:	John Finlay
   Comments:	Defines an array of GEDCOM codes and the dutch name facts that they represent.
   Change Log:	8/5/02 - File Created
		20030517 - Modified by Erik Bent (hjbent@users.sourceforge.net)
		2003-10-21 - Updated to version 2.52b3 by Boudewijn Sjouke
		2004-01-02 - Updated to version 2.65 Final by Jans B. Luder
===================================================*/
# $Id: facts.nl.php,v 1.14.2.1 2004/01/26 22:33:37 yalnifj Exp $
if (preg_match("/facts\...\.php$/", $_SERVER["PHP_SELF"])>0) {
	print "You cannot access a language file directly.";
	exit;
}
// -- Define a fact array to map Gedcom tags with their Dutch values
$factarray["ABBR"] 	= "Afkorting";
$factarray["ADDR"] 	= "Adres";
$factarray["ADR1"] 	= "Adres 1";
$factarray["ADR2"] 	= "Adres 2";
$factarray["ADOP"] 	= "Adoptie";
$factarray["AFN"] 	= "Bestandsnummer stamvaders (AFN)";
$factarray["AGE"] 	= "Leeftijd";
$factarray["AGNC"] 	= "Instantie";
$factarray["ALIA"] 	= "Verwijzing";
$factarray["ANCE"] 	= "Voorouders";
$factarray["ANCI"] 	= "Interessante voorouders";
$factarray["ANUL"] 	= "Vernietiging";
$factarray["ASSO"] 	= "Kennissen";
$factarray["AUTH"] 	= "Auteur";
$factarray["BAPL"] 	= "LDS Doop";
$factarray["BAPM"] 	= "Gedoopt";
$factarray["BARM"] 	= "Bar mitswa";
$factarray["BASM"] 	= "Bas mitswa";
$factarray["BIRT"] 	= "Geboorte";
$factarray["BLES"] 	= "Zegening";
$factarray["BLOB"] 	= "Binaire data";
$factarray["BURI"] 	= "Begrafenis";
$factarray["CALN"] 	= "Inventarisnummer";
$factarray["CAST"] 	= "Kaste / sociale status";
$factarray["CAUS"] 	= "Doodsoorzaak";
$factarray["CENS"] 	= "Volkstelling";
$factarray["CHAN"] 	= "Laatste wijziging";
$factarray["CHAR"] 	= "Karakterset";
$factarray["CHIL"] 	= "Kind";
$factarray["CHR"] 	= "Gedoopt";
$factarray["CHRA"] 	= "Volwassen doop";
$factarray["CITY"] 	= "Stad";
$factarray["CONF"] 	= "Bevestiging";
$factarray["CONL"] 	= "LDS bevestiging";
$factarray["COPR"] 	= "Copyright";
$factarray["CORP"] 	= "Bedrijf";
$factarray["CREM"] 	= "Crematie";
$factarray["CTRY"] 	= "Land";
$factarray["DATA"] 	= "Data";
$factarray["DATE"] 	= "Datum";
$factarray["DEAT"] 	= "Overleden";
$factarray["DESC"] 	= "Nakomelingen";
$factarray["DESI"] 	= "Interessante nakomelingen";
$factarray["DEST"] 	= "Bestemming";
$factarray["DIV"] 	= "Scheiding";
$factarray["DIVF"] 	= "Scheiding ingediend";
$factarray["DSCR"] 	= "Omschrijving";
$factarray["EDUC"] 	= "Opleiding";
$factarray["EMIG"] 	= "Emigratie";
$factarray["ENDL"] 	= "LDS gave";
$factarray["ENGA"] 	= "Verloving";
$factarray["EVEN"] 	= "Gebeurtenis";
$factarray["FAM"] 	= "Gezin";
$factarray["FAMC"] 	= "Gezinsleden van kind";
$factarray["FAMF"] 	= "Gezinsbestand";
$factarray["FAMS"] 	= "Gezinsleden van ega";
$factarray["FCOM"] 	= "Eerste communie";
$factarray["FILE"] 	= "Extern bestand:";
$factarray["FORM"] 	= "Formaat:";
$factarray["GIVN"] 	= "Voorna(a)m(en)";
$factarray["GRAD"] 	= "Geslaagd";
$factarray["IDNO"] 	= "Identificatie Nummer";
$factarray["IMMI"] 	= "Immigratie";
$factarray["LEGA"] 	= "Legataris";
$factarray["MARB"] 	= "Ondertrouw";
$factarray["MARC"] 	= "Huwelijkscontract";
$factarray["MARL"]	= "Huwelijkstoestemming";
$factarray["MARR"]	= "Huwelijk";
$factarray["MARS"] 	= "Huwelijksvoorwaarden";
$factarray["NAME"] 	= "Naam";
$factarray["NATI"] 	= "Nationaliteit";
$factarray["NATU"] 	= "Naturalisatie";
$factarray["NCHI"] 	= "Aantal kinderen";
$factarray["NICK"] 	= "Roepnaam";
$factarray["NMR"] 	= "Aantal huwelijken";
$factarray["NOTE"] 	= "Notitie";
$factarray["NPFX"] 	= "Voorvoegsel";
$factarray["NSFX"] 	= "Achtervoegsel";
$factarray["OBJE"] 	= "Multimedia object";
$factarray["OCCU"] 	= "Beroep";
$factarray["ORDI"] 	= "Ritueel";
$factarray["ORDN"] 	= "Wijding";
$factarray["PAGE"] 	= "Citaat verwijzing";
$factarray["PEDI"] 	= "Kwartierstaat";
$factarray["PLAC"] 	= "Plaats";
$factarray["PHON"] 	= "Telefoon";
$factarray["POST"] 	= "Postcode";
$factarray["PROB"] 	= "Wilserkenning";
$factarray["PROP"] 	= "Eigendom";
$factarray["PUBL"] 	= "Publicatie";
$factarray["QUAY"] 	= "Kwaliteit van de data";
$factarray["REPO"] 	= "Bewaarplaats";
$factarray["REFN"] 	= "Referentie nummer";
$factarray["RELI"] 	= "Religie";
$factarray["RESI"] 	= "Woonplaats";
$factarray["RESN"] 	= "Beperking";
$factarray["RETI"] 	= "Pensioen";
$factarray["RFN"] 	= "Record bestandsnummer";
$factarray["RIN"] 	= "Record ID nummer";
$factarray["ROLE"] 	= "Rol";
$factarray["SEX"] 	= "Geslacht";
$factarray["SLGC"] 	= "LDS kind verzegeling";
$factarray["SLGS"] 	= "LDS ega verzegeling";
$factarray["SOUR"] 	= "Bron";
$factarray["SPFX"] 	= "Voorvoegsel achternaam";
$factarray["SSN"] 	= "SOFI nummer";
$factarray["STAE"] 	= "Staat";
$factarray["STAT"] 	= "Status";
$factarray["SUBM"] 	= "Doorgegeven door";
$factarray["SUBN"] 	= "Aanlevering";
$factarray["SURN"] 	= "Achternaam";
$factarray["TEMP"] 	= "Tempel";
$factarray["TEXT"] 	= "Tekst";
$factarray["TIME"] 	= "Tijd";
$factarray["TITL"] 	= "Titel";
$factarray["TYPE"] 	= "Type";
$factarray["WILL"] 	= "Testament";
$factarray["_EMAIL"] 	= "E-mail adres";
$factarray["EMAIL"] 	= "E-mail adres";
$factarray["_TODO"] 	= "Te doen";
$factarray["_UID"] 	= "Universeel kenmerk (UID)";

// These facts are specific to gedcom exports from Family Tree Maker
$factarray["_MDCL"] 	= "Medisch";
$factarray["_DEG"] 	= "Graad";
$factarray["_MILT"] 	= "Militaire dienst";
$factarray["_SEPR"] 	= "Gescheiden";
$factarray["_DETS"] 	= "Dood van een echtgenoot";
$factarray["CITN"] 	= "Staatsburgerschap";
$factarray["_MEND"] = "Status einde huwelijk";
$factarray["_MSTAT"] = "Status aanvang huwelijk";
$factarray["_FA1"] = "Huwelijksfeit";
$factarray["_FREL"] = "Relatie met vader";
$factarray["_MREL"] = "Relatie met moeder";
$factarray["_FA13"] = "Feit 13";
$factarray["_FA12"] = "Feit 12";
$factarray["_FA11"] = "Feit 11";
$factarray["_FA10"] = "Feit 10";
$factarray["_FA9"] = "Feit 9";
$factarray["_FA8"] = "Feit 8";
$factarray["_FA7"] = "Feit 7";
$factarray["_FA6"] = "Feit 6";
$factarray["_FA5"] = "Feit 5";
$factarray["_FA4"] = "Feit 4";
$factarray["_FA3"] = "Feit 3";
$factarray["_FA2"] = "Feit 2";
$factarray["_FA1"] = "Feit 1";

// Other common customized facts
$factarray["_ADPF"] 	= "Geadopteerd door de vader";
$factarray["_ADPM"] 	= "Geadopteerd door de moeder";
$factarray["_AKAN"] 	= "Ook bekend als";
$factarray["_AKA"]	= "Ook bekend als";
$factarray["_BRTM"] 	= "Besnijdenis";
$factarray["_COML"] 	= "Erkend partnerschap";
$factarray["_EYEC"] 	= "Kleur ogen";
$factarray["_FNRL"] 	= "Begrafenis";
$factarray["_HAIR"] 	= "Kleur haar";
$factarray["_HEIG"] 	= "Lengte";
$factarray["_INTE"] 	= "Bijgezet";
$factarray["_MARI"] 	= "Huwelijksvoornemen";
$factarray["_MBON"] 	= "Ondertrouw";
$factarray["_MEDC"] 	= "Medische toestand";
$factarray["_MILI"] 	= "Militaire dienst";
$factarray["_NMR "] 	= "Ongehuwd";
$factarray["_NLIV"] 	= "Overleden";
$factarray["_NMAR"] 	= "Nooit gehuwd";
$factarray["_PRMN"] 	= "Permanent nummer";
$factarray["_SEPR"]	= "Gescheiden";
$factarray["_WEIG"] 	= "Gewicht";
$factarray["_YART"] 	= "Yartzeit";

if (file_exists($PGV_BASE_DIRECTORY . "languages/facts.nl.extra.php")) require $PGV_BASE_DIRECTORY . "languages/facts.nl.extra.php";

?>