<?php
/*=================================================
   charset=utf-8
   Project:	phpGedView
   File:	facts.no.php
   Author:	John Finlay
   Translation:	Geir Håkon Eikland
   Comments:	Defines an array of GEDCOM codes and the norwegian name facts that they represent.
   Change Log:	7/1/04 - File Created
===================================================*/
# $Id: facts.no.php,v 1.3.2.1 2004/01/26 22:33:37 yalnifj Exp $
if (preg_match("/facts\...\.php$/", $_SERVER["PHP_SELF"])>0) {
	print "You cannot access a language file directly.";
	exit;
}
// -- Define a fact array to map Gedcom tags with their norwegian values
$factarray["ABBR"] = "Forkortelse";
$factarray["ADDR"] = "Adresse";
$factarray["ADR1"] = "Adresse 1";
$factarray["ADR2"] = "Adresse 2";
$factarray["ADOP"] = "Adopsjon";
$factarray["AFN"]  = "Ancestral File Number (AFN)";
$factarray["AGE"]  = "Alder";
$factarray["AGNC"] = "Agentur";
$factarray["ALIA"] = "Alias";
$factarray["ANCE"] = "Forfedre";
$factarray["ANCI"] = "Slekt forbindelse";
$factarray["ANUL"] = "Annullering";
$factarray["ASSO"] = "Forbindelser";
$factarray["AUTH"] = "Forfatter";
$factarray["BAPL"] = "LDS Dåp";
$factarray["BAPM"] = "Døpt";
$factarray["BARM"] = "Bar Mitzvah";
$factarray["BASM"] = "Bas Mitzvah";
$factarray["BIRT"] = "Født";
$factarray["BLES"] = "Velsignelse";
$factarray["BLOB"] = "Binært dataobjekt";
$factarray["BURI"] = "Begravelse";
$factarray["CALN"] = "Kallenummer";
$factarray["CAST"] = "Kaste / Sosial status";
$factarray["CAUS"] = "Dødsårsak";
$factarray["CENS"] = "Folketelling";
$factarray["CHAN"] = "Siste endring";
$factarray["CHAR"] = "Tegnsett";
$factarray["CHIL"] = "Barn";
$factarray["CHR"]  = "Barnedåp";
$factarray["CHRA"] = "Voksen-/troendesdåp";
$factarray["CITY"] = "By";
$factarray["CONF"] = "Konfirmasjon";
$factarray["CONL"] = "LDS konfirmert";
$factarray["COPR"] = "Opphavsrett";
$factarray["CORP"] = "Bedrift / Firma";
$factarray["CREM"] = "Kremering";
$factarray["CTRY"] = "Kommune";
$factarray["DATE"] = "Dato";
$factarray["DATA"] = "Data";
$factarray["DEAT"] = "Død";
$factarray["DESC"] = "Avstamning";
$factarray["DESI"] = "Etterkommer forbindelse";
$factarray["DEST"] = "Mål";
$factarray["DIV"]  = "Skilsmisse";
$factarray["DIVF"] = "Skilsmissebegjæring";
$factarray["DSCR"] = "Beskrivelse";
$factarray["EDUC"] = "Uddannelse";
$factarray["EMIG"] = "Utvandring";
$factarray["ENDL"] = "LDS gave";
$factarray["ENGA"] = "Forlovelse";
$factarray["EVEN"] = "Begivenhet";
$factarray["FAM"]  = "Familie";
$factarray["FAMC"] = "Familie som barn";
$factarray["FAMF"] = "Familiefil";
$factarray["FAMS"] = "Familie som gift/partner";
$factarray["FCOM"] = "Første forbindelse";
$factarray["FILE"] = "Ekstern fil:";
$factarray["FORM"] = "Format:";
$factarray["GIVN"] = "Fornavn";
$factarray["GRAD"] = "Avgangseksamen";
$factarray["IDNO"] = "Identifikasjonsnummer";
$factarray["IMMI"] = "Innvandring";
$factarray["LEGA"] = "Arving";
$factarray["MARB"] = "Lysning";
$factarray["MARC"] = "Ekteskapskontrakt";
$factarray["MARL"] = "Ekteskapsbrev";
$factarray["MARR"] = "Ekteskap";
$factarray["MARS"] = "Ekteskapsavtale";
$factarray["NAME"] = "Navn";
$factarray["NATI"] = "Nasjonalitet";
$factarray["NATU"] = "Naturalisering";
$factarray["NCHI"] = "Antall barn";
$factarray["NICK"] = "Øke/kj&oelig;le-navn";
$factarray["NMR"]  = "Antall ekteskap";
$factarray["NOTE"] = "Notat";
$factarray["NPFX"] = "Prefiks";
$factarray["NSFX"] = "Suffiks";
$factarray["OBJE"] = "Multimedia objekt";
$factarray["OCCU"] = "Yrke";
$factarray["ORDI"] = "Orden";
$factarray["ORDN"] = "Ordinasjon";
$factarray["PAGE"] = "Dokumenttekst detaljer";
$factarray["PEDI"] = "Slektskap";
$factarray["PLAC"] = "Stednavn";
$factarray["PHON"] = "Tlf.";
$factarray["POST"] = "Postnummer";
$factarray["PROB"] = "Skifte";
$factarray["PROP"] = "Eiendom";
$factarray["PUBL"] = "Publikasjon";
$factarray["QUAY"] = "Datakvalitet";
$factarray["REPO"] = "Oppbevaringssted";
$factarray["REFN"] = "Referensenummer";
$factarray["RELI"] = "Religion";
$factarray["RESI"] = "Bosted";
$factarray["RESN"] = "Restriksjon";
$factarray["RETI"] = "Pensjonering";
$factarray["RFN"]  = "Post-fil-nummer";
$factarray["RIN"]  = "Post-ID-nummer";
$factarray["ROLE"] = "Rolle";
$factarray["SEX"]  = "Kjønn";
$factarray["SLGC"] = "LDS Barn-kobling";
$factarray["SLGS"] = "LDS Ektefellekobling";
$factarray["SOUR"] = "Kilde";
$factarray["SPFX"] = "Etternavns prefiks";
$factarray["SSN"]  = "Personnummer";
$factarray["STAE"] = "Stat";
$factarray["STAT"] = "Status";
$factarray["SUBM"] = "Avsender";
$factarray["SUBN"] = "Innmelding";
$factarray["SURN"] = "Etternavn";
$factarray["TEMP"] = "Sermonisted";
$factarray["TEXT"] = "Tekst";
$factarray["TIME"] = "Tid";
$factarray["TITL"] = "Tittel";
$factarray["TYPE"] = "Type";
$factarray["WILL"] = "Testament";
$factarray["_EMAIL"] = "E-post-adresse";
$factarray["EMAIL"] = "E-post-adresse";
$factarray["_TODO"] = "Ting å gjøre";
$factarray["_UID"] = "Universell Identifikator";

// These facts are specific to gedcom exports from Family Tree Maker
$factarray["_MDCL"] = "Helse";
$factarray["_DEG"] = "Akademisk grad";
$factarray["_MILT"] = "Militærtjeneste";
$factarray["_SEPR"] = "Separeret";
$factarray["_DETS"] = "Ektefelles død";
$factarray["CITN"] = "Statsborgerskap";

// These facts are specific to gedcom exports from Brothers Keeper
$factarray["_ADPF"] = "Adopteret av far";
$factarray["_ADPM"] = "Adopteret av mor";
$factarray["_AKAN"] = "Også kjent som";
$factarray["_BRTM"] = "Brit mila";
$factarray["_EYEC"] = "Øyefarge";
$factarray["_WEIG"] = "Vekt";
$factarray["_YART"] = "Yartzeit";
$factarray["_COML"] = "Lovlig ekteskap";
$factarray["_MILI"] = "Milit&oelig;rtjeneste";
$factarray["_NMR "] = "Ikke gift";
$factarray["_NLIV"] = "Lever ikke";
$factarray["_HAIR"] = "Hårfarve";
$factarray["_HEIG"] = "Høyde";
$factarray["_INTE"] = "Interneret";
$factarray["_MARI"] = "Ekteskaps-intensjon";
$factarray["_MBON"] = "Ekteskapsbånd";
$factarray["_MEDC"] = "Helsetilstand";
$factarray["_FNRL"] = "Bisettelse";
$factarray["_NMAR"] = "Aldri gift";
$factarray["_PRMN"] = "Permanent nummer";

if (file_exists($PGV_BASE_DIRECTORY . "languages/facts.no.extra.php")) require $PGV_BASE_DIRECTORY . "languages/facts.no.extra.php";

?>