<?php
/*=================================================
   charset=utf-8
   Project:	phpGedView
   File:	facts.pl.php  [v.0.51 compatible with PHPGedView v. 2.53]
   Author: 	Tymoteusz Motylewski www.motylewscy.com
   		earlier version Michael Paluchowski, www.nethut.pl/gen/
   Comments:	Defines an array of GEDCOM codes and the polish name facts that they represent.
   Change Log:	3/3/02 - File Created by Michael Paluchowski, www.nethut.pl/gen/
		5/11/30 - Spelling and encoding checked, new variables added.
===================================================*/
# $Id: facts.pl.php,v 1.8.2.1 2004/01/26 22:33:37 yalnifj Exp $
if (preg_match("/facts\...\.php$/", $_SERVER["PHP_SELF"])>0) {
	print "You cannot access a language file directly.";
	exit;
}
// -- Define a fact array to map Gedcom tags with their polish values
$factarray["ABBR"] = "Skrót";
$factarray["ADDR"] = "Addres";
$factarray["ADR1"] = "Addres 1";
$factarray["ADR2"] = "Addres 2";
$factarray["ADOP"] = "Adopcja";
$factarray["AFN"] = "Ancestral File Number (AFN)";
$factarray["AGE"] = "Wiek";
$factarray["AGNC"] = "Agencja";
$factarray["ALIA"] = "Inaczej";
$factarray["ANCE"] = "Przodkowie";
$factarray["ANCI"] = "Udział Przodków";
$factarray["ANUL"] = "Unieważnienie";
$factarray["ASSO"] = "Połączenia";
$factarray["AUTH"] = "Autor";
$factarray["BAPL"] = "Chrzest Mormoński";
$factarray["BAPM"] = "Chrzest";
$factarray["BARM"] = "Bar Mitzva";
$factarray["BASM"] = "Bas Mitzva";
$factarray["BIRT"] = "Narodziny";
$factarray["BLES"] = "Błogosławieństwo";
$factarray["BLOB"] = "Obiekt Binarny";
$factarray["BURI"] = "Pogrzeb";
$factarray["CALN"] = "Numer źródła";
$factarray["CAST"] = "Kasta / Status Społeczny";
$factarray["CAUS"] = "Cause of death";
$factarray["CENS"] = "Spis Powszechny";
$factarray["CHAN"] = "Ostatnia Zmiana";
$factarray["CHAR"] = "Zestaw Znaków";
$factarray["CHIL"] = "Dziecko";
$factarray["CHR"] = "Chrzciny";
$factarray["CHRA"] = "Chrzciny Dorosłego";
$factarray["CITY"] = "Miasto";
$factarray["CONF"] = "Bierzmowanie";
$factarray["CONL"] = "Bierzmowanie Mormońskie";
$factarray["COPR"] = "Prawa Autorskie";
$factarray["CORP"] = "Korporacja / Firma";
$factarray["CREM"] = "Kremacja";
$factarray["CTRY"] = "Kraj";
$factarray["DATA"] = "Dane";
$factarray["DATE"] = "Date";
$factarray["DEAT"] = "Śmierć";
$factarray["DESC"] = "Potomkowie";
$factarray["DESI"] = "Udział Potomków";
$factarray["DEST"] = "Cel";
$factarray["DIV"] = "Rozwód";
$factarray["DIVF"] = "Uzyskanie Rozwodu";
$factarray["DSCR"] = "Opis";
$factarray["EDUC"] = "Edukacja";
$factarray["EMIG"] = "Emigracja";
$factarray["ENDL"] = "Posag Mormoński";
$factarray["ENGA"] = "Zaręczyny";
$factarray["EVEN"] = "Wydarzenie";
$factarray["FAM"] = "Rodzina";
$factarray["FAMC"] = "W Rodzinie jako Dziecko";
$factarray["FAMF"] = "Dane Rodziny";
$factarray["FAMS"] = "W Rodzinie jako Małżonek";
$factarray["FCOM"] = "Pierwsza Komunia";
$factarray["FILE"] = "Zewnętrzny Plik";
$factarray["FORM"] = "Format";
$factarray["GIVN"] = "Imię (Imiona)";
$factarray["GRAD"] = "Ukończenie Studiów";
$factarray["IDNO"] = "Numer Identyfikacyjny";
$factarray["IMMI"] = "Imigracja";
$factarray["LEGA"] = "Legatariusz / Zapisobiorca";
$factarray["MARB"] = "Zapowiedzi";
$factarray["MARC"] = "Kontrakt Małżeński";
$factarray["MARL"] = "Licencja Małżeńska";
$factarray["MARR"] = "Ślub";
$factarray["MARS"] = "Układ Małżeński";
$factarray["NAME"] = "Nazwisko";
$factarray["NATI"] = "Narodowość";
$factarray["NATU"] = "Naturalizacja";
$factarray["NCHI"] = "Ilość dzieci";
$factarray["NICK"] = "Pseudonim";
$factarray["NMR"] = "Liczba małżeństw";
$factarray["NOTE"] = "Notka";
$factarray["NPFX"] = "Prefiks";
$factarray["NSFX"] = "Sufiks";
$factarray["OBJE"] = "Obiekt Multimedialny";
$factarray["OCCU"] = "Zawód";
$factarray["ORDI"] = "Obrządek";
$factarray["ORDN"] = "Wyznanie";
$factarray["PAGE"] = "Szczególy Cytatu";
$factarray["PEDI"] = "Rodowód";
$factarray["PLAC"] = "Miejsce";
$factarray["PHON"] = "Telefon";
$factarray["POST"] = "Kod Pocztowy";
$factarray["PROB"] = "Poświadczenie Autentycznoęci Testamentu";
$factarray["PROP"] = "Własność";
$factarray["PUBL"] = "Publikacja";
$factarray["QUAY"] = "Jakość danych";
$factarray["REPO"] = "Repository";
$factarray["REFN"] = "Numer Referencyjny";
$factarray["RELI"] = "Wyznanie";
$factarray["RESI"] = "Miejsce Zamieszkania";
$factarray["RESN"] = "Ograniczenie";
$factarray["RETI"] = "Przejście na emeryture";
$factarray["RFN"] = "Record file number";
$factarray["RIN"] = "Record ID Number";
$factarray["ROLE"] = "Role";
$factarray["SEX"] = "Płeć";
$factarray["SLGC"] = "Mormońskie Naznaczenie Dziecka";
$factarray["SLGS"] = "Mormońskie Naznaczenie Małżonka";
$factarray["SOUR"] = "Źródło";
$factarray["SPFX"] = "Prefiks Nazwiska";
$factarray["SSN"] = "Numer Ubezpieczenia";
$factarray["STAE"] = "Stan";
$factarray["STAT"] = "Status";
$factarray["SUBM"] = "Wpisał Dane";
$factarray["SUBN"] = "Wpis";
$factarray["SURN"] = "Nazwisko";
$factarray["TEMP"] = "Świątynia";
$factarray["TEXT"] = "Tekst";
$factarray["TIME"] = "Czas";
$factarray["TITL"] = "Tytuł";
$factarray["TYPE"] = "Type";
$factarray["WILL"] = "Testament";
$factarray["_EMAIL"] = "Adres Email";
$factarray["_TODO"] = "Do Zrobienia";
$factarray["_UID"] = "Uniwersalny Identyfikator";

// These facts are specific to gedcom exports from Family Tree Maker
$factarray["_MDCL"] = "Medical";
$factarray["_DEG"] = "Degree";
$factarray["_MILT"] = "Military Service";
$factarray["_SEPR"] = "Separated";
$factarray["_DETS"] = "Death of One Spouse";
$factarray["CITN"] = "Citizenship";

// Other common customized facts
$factarray["_ADPF"]	= "Adopted by father";

if (file_exists($PGV_BASE_DIRECTORY . "languages/facts.pl.extra.php")) require $PGV_BASE_DIRECTORY . "languages/facts.pl.extra.php";

?>