<?php
/*=================================================
   charset=utf-8
   Project:	phpGedView
   File:	facts.pt-br.php
   Author:	John Finlay
   Comments:	Defines an array of GEDCOM codes and the brasilian portugese name facts that they represent.
   Change Log:	8/5/02 - File Created
===================================================*/
# $Id: facts.pt-br.php,v 1.1.2.2 2004/01/29 15:32:18 yalnifj Exp $
if (preg_match("/facts\..+\.php$/", $_SERVER["PHP_SELF"])>0) {
	print "You cannot access a language file directly.";
	exit;
}
// -- Define a fact array to map Gedcom tags with their brasilian portugese values
$factarray["ABBR"] = "Abreviação";
$factarray["ADDR"] = "Endereço";
$factarray["ADR1"] = "Endereço 1";
$factarray["ADR2"] = "Endereço 2";
$factarray["ADOP"] = "Adoção";
$factarray["AFN"] = "Ancestral File Number (AFN)";
$factarray["AGE"] = "Idade";
$factarray["AGNC"] = "Agencia";
$factarray["ALIA"] = "Apelido";
$factarray["ANCE"] = "Ancestrais";
$factarray["ANCI"] = "Ancestors Interest";
$factarray["ANUL"] = "Annulment";
$factarray["ASSO"] = "Associates";
$factarray["AUTH"] = "Autor";
$factarray["BAPL"] = "LDS Baptism";
$factarray["BAPM"] = "Batismo";
$factarray["BARM"] = "Bar Mitzvah";
$factarray["BASM"] = "Bas Mitzvah";
$factarray["BIRT"] = "Nascimento";
$factarray["BLES"] = "Blessing";
$factarray["BLOB"] = "Binary Data Object";
$factarray["BURI"] = "Enterro";
$factarray["CALN"] = "Call Number";
$factarray["CAST"] = "Caste / Social Status";
$factarray["CAUS"] = "Causa da Morte";
$factarray["CENS"] = "Census";
$factarray["CHAN"] = "Última Alteração";
$factarray["CHAR"] = "Character Set";
$factarray["CHIL"] = "Filho";
$factarray["CHR"] = "Batizado";
$factarray["CHRA"] = "Adult Christening";
$factarray["CITY"] = "Cidade";
$factarray["CONF"] = "Confirmação";
$factarray["CONL"] = "LDS Confirmation";
$factarray["COPR"] = "Copyright";
$factarray["CORP"] = "Corporação / Compania";
$factarray["CREM"] = "Cremação";
$factarray["CTRY"] = "País";
$factarray["DATA"] = "Dados";
$factarray["DATE"] = "Data";
$factarray["DEAT"] = "Morte";
$factarray["DESC"] = "Descendentes";
$factarray["DESI"] = "Descendents Interest";
$factarray["DEST"] = "Destinação";
$factarray["DIV"] = "Divórcio";
$factarray["DIVF"] = "Divorce Filed";
$factarray["DSCR"] = "Descrição";
$factarray["EDUC"] = "Educação";
$factarray["EMIG"] = "Emigração";
$factarray["ENDL"] = "LDS Endowment";
$factarray["ENGA"] = "Engagement";
$factarray["EVEN"] = "Evento";
$factarray["FAM"] = "Família";
$factarray["FAMC"] = "Family as a Child";
$factarray["FAMF"] = "Family File";
$factarray["FAMS"] = "Family as a Spouse";
$factarray["FCOM"] = "Primeira Comunhão";
$factarray["FILE"] = "Arquivo Externo:";
$factarray["FORM"] = "Formato:";
$factarray["GIVN"] = "Nome(s)";
$factarray["GRAD"] = "Graduation";
$factarray["IDNO"] = "Identification Number";
$factarray["IMMI"] = "Immigration";
$factarray["LEGA"] = "Legatee";
$factarray["MARB"] = "Marriage Bann";
$factarray["MARC"] = "Marriage Contract";
$factarray["MARL"] = "Licença de Casamento";
$factarray["MARR"] = "Casamento";
$factarray["MARS"] = "Marriage Settlement";
$factarray["NAME"] = "Nome";
$factarray["NATI"] = "Nationality";
$factarray["NATU"] = "Naturalização";
$factarray["NCHI"] = "Número de Filhos";
$factarray["NICK"] = "Apelido";
$factarray["NMR"] = "Número de Casamentos";
$factarray["NOTE"] = "Nota";
$factarray["NPFX"] = "Prefixo";
$factarray["NSFX"] = "Sufixo";
$factarray["OBJE"] = "Fotos";
$factarray["OCCU"] = "Occupation";
$factarray["ORDI"] = "Ordinance";
$factarray["ORDN"] = "Ordination";
$factarray["PAGE"] = "Citation Details";
$factarray["PEDI"] = "Árvore Genealógica";
$factarray["PLAC"] = "Place";
$factarray["PHON"] = "Telefone";
$factarray["POST"] = "CEP";
$factarray["PROB"] = "Probate";
$factarray["PROP"] = "Propriedade";
$factarray["PUBL"] = "Publicação";
$factarray["QUAY"] = "Quality of data";
$factarray["REPO"] = "Repository";
$factarray["REFN"] = "Reference Number";
$factarray["RELI"] = "Religião";
$factarray["RESI"] = "Residência";
$factarray["RESN"] = "Restrição";
$factarray["RETI"] = "Retirement";
$factarray["RFN"] = "Record file number";
$factarray["RIN"] = "Record ID Number";
$factarray["ROLE"] = "Role";
$factarray["SEX"] = "Sexo";
$factarray["SLGC"] = "LDS Child Sealing";
$factarray["SLGS"] = "LDS Spouse Sealing";
$factarray["SOUR"] = "Fonte";
$factarray["SPFX"] = "Prefixo do Sobrenome";
$factarray["SSN"] = "Social Security Number";
$factarray["STAE"] = "Estado";
$factarray["STAT"] = "Status";
$factarray["SUBM"] = "Submitter";
$factarray["SUBN"] = "Submission";
$factarray["SURN"] = "Sobrenome";
$factarray["TEMP"] = "Templo";
$factarray["TEXT"] = "Texto";
$factarray["TIME"] = "Tempo";
$factarray["TITL"] = "Title";
$factarray["TYPE"] = "Tipo";
$factarray["WILL"] = "Will";
$factarray["_EMAIL"] = "Email Address";
$factarray["EMAIL"] = "E-mail";
$factarray["_TODO"] = "To Do Item";
$factarray["_UID"] = "Universal Identifier";

// These facts are specific to gedcom exports from Family Tree Maker
$factarray["_MDCL"] = "Medical";
$factarray["_DEG"] = "Degree";
$factarray["_MILT"] = "Serviço Militar";
$factarray["_SEPR"] = "Separated";
$factarray["_DETS"] = "Morte de um Conjuge";
$factarray["CITN"] = "Cidadania";

// Other common customized facts
$factarray["_ADPF"] = "Adopted by father";
$factarray["_ADPM"] = "Adopted by mother";
$factarray["_AKAN"] = "Also known as";
$factarray["_BRTM"] = "Brit mila";
$factarray["_COML"] = "Common Law marriage";
$factarray["_EYEC"] = "Eye color";
$factarray["_FNRL"] = "Funeral";
$factarray["_HAIR"] = "Cor do Cabelo";
$factarray["_HEIG"] = "Height";
$factarray["_INTE"] = "Interred";
$factarray["_MARI"] = "Marriage intention";
$factarray["_MBON"] = "Marriage bond";
$factarray["_MEDC"] = "Medical condition";
$factarray["_MILI"] = "Military";
$factarray["_NMR "] = "Not married";
$factarray["_NLIV"] = "Not living";
$factarray["_NMAR"] = "Never married";
$factarray["_PRMN"] = "Permanent Number";
$factarray["_SEPR"] = "Separated";
$factarray["_WEIG"] = "Peso";
$factarray["_YART"] = "Yartzeit";

if (file_exists($PGV_BASE_DIRECTORY . "languages/facts.pt-br.extra.php")) require $PGV_BASE_DIRECTORY . "languages/facts.pt-br.extra.php";

?>