<?php
/*=================================================
   charset=utf-8
   Project:	phpGedView
   File:	facts.ru.php
   Authors:	John Finlay, Eugene Fedorov
   Comments:	Defines an array of GEDCOM codes and the Russian name facts that they
		represent. CP-1251 not to be used in multi-language environment.
   Change Log:	8/5/02 - File Created
		1/2/02 - Translated into Russian
===================================================*/
# $Id: facts.ru.php,v 1.8 2003/12/09 16:23:49 yalnifj Exp $
if (preg_match("/facts\...\.php$/", $_SERVER["PHP_SELF"])>0) {
	print "You cannot access a language file directly.";
	exit;
}
// -- Define a fact array to map Gedcom tags with their Russian values
$factarray["ABBR"] = "Сокращение";
$factarray["ADDR"] = "Адрес";
$factarray["ADR1"] = "Адрес 1";
$factarray["ADR2"] = "Адрес 2";
$factarray["ADOP"] = "Усыновление";
$factarray["AFN"] = "AFN";
$factarray["AGE"] = "Возраст";
$factarray["AGNC"] = "Учреждение";
$factarray["ALIA"] = "Иначе";
$factarray["ANCE"] = "Предки";
$factarray["ANCI"] = "Предки представляют интерес";
$factarray["ANUL"] = "Признание брака недействительным";
$factarray["ASSO"] = "Знакомые";
$factarray["AUTH"] = "Автор";
$factarray["BAPL"] = "Крещение у мормонов";
$factarray["BAPM"] = "Крешение";
$factarray["BARM"] = "Бар-мицва";
$factarray["BASM"] = "Бас-мицва";
$factarray["BIRT"] = "Рождение";
$factarray["BLES"] = "Благословение";
$factarray["BLOB"] = "Бинарный объект данных";
$factarray["BURI"] = "Захоронение";
$factarray["CALN"] = "Шифр";
$factarray["CAST"] = "Каста или сословие";
$factarray["CAUS"] = "Причина смерти";
$factarray["CENS"] = "Перепись";
$factarray["CHAN"] = "Последнее изменение";
$factarray["CHAR"] = "Кодировка";
$factarray["CHIL"] = "Ребенок";
$factarray["CHR"] = "Крещение";
$factarray["CHRA"] = "Крещение взрослого";
$factarray["CITY"] = "Населенный пункт";
$factarray["CONC"] = "Конкатенация";
$factarray["CONF"] = "Конфирмация";
$factarray["CONL"] = "Конфирмация у мормонов";
$factarray["CONT"] = "Продолжение";
$factarray["COPR"] = "Авторские права";
$factarray["CORP"] = "Фирма";
$factarray["CREM"] = "Кремация";
$factarray["CTRY"] = "Страна";
$factarray["DATA"] = "Данные";
$factarray["DATE"] = "Дата";
$factarray["DEAT"] = "Кончина";
$factarray["DESC"] = "Потомки";
$factarray["DESI"] = "Потомки представляют интерес";
$factarray["DEST"] = "Назначение";
$factarray["DIV"] = "Развод";
$factarray["DIVF"] = "Дело о разводе";
$factarray["DSCR"] = "Приметы";
$factarray["EDUC"] = "Образование";
$factarray["EMIG"] = "Эмиграция";
$factarray["ENDL"] = "LDS Endowment";
$factarray["ENGA"] = "Помолвка";
$factarray["EVEN"] = "Событие";
$factarray["FAM"] = "Семья";
$factarray["FAMC"] = "Семья в детстве";
$factarray["FAMF"] = "Семейный файл у мормонов";
$factarray["FAMS"] = "Семья в браке";
$factarray["FCOM"] = "Первое причастие";
$factarray["FILE"] = "Внешний файл";
$factarray["FORM"] = "Формат";
$factarray["GIVN"] = "Имя, отчество (имена)";
$factarray["GRAD"] = "Образование (диплом)";
$factarray["HEAD"] = "Заголовок";
$factarray["HUSB"] = "Супруг";
$factarray["IDNO"] = "Идентификационный номер";
$factarray["IMMI"] = "Иммиграция";
$factarray["LANG"] = "Язык";
$factarray["LEGA"] = "Наследник";
$factarray["MARB"] = "Объявление о браке";
$factarray["MARC"] = "Брачный контракт";
$factarray["MARL"] = "Разрешение на брак";
$factarray["MARR"] = "Брак";
$factarray["MARS"] = "Соглашение о браке";
$factarray["NAME"] = "Фамилия, имя, отчество (имена)";
$factarray["NATI"] = "Национальность";
$factarray["NATU"] = "Натурализация";
$factarray["NCHI"] = "Число детей";
$factarray["NICK"] = "Прозвище";
$factarray["NMR"] = "Число браков";
$factarray["NOTE"] = "Примечание";
$factarray["NPFX"] = "Титул (приставка)";
$factarray["NSFX"] = "Суффикс";
$factarray["OBJE"] = "Объект";
$factarray["OCCU"] = "Род занятий";
$factarray["ORDI"] = "Посвящение у мормонов";
$factarray["ORDN"] = "Посвящение в сан";
$factarray["PAGE"] = "Местонахождение цитаты";
$factarray["PEDI"] = "Восходящее древо";
$factarray["PLAC"] = "Место";
$factarray["PHON"] = "Телефон";
$factarray["POST"] = "Почтовый код";
$factarray["PROB"] = "Утверждение завещания";
$factarray["PROP"] = "Собственность";
$factarray["PUBL"] = "Публикация";
$factarray["QUAY"] = "Качество данных";
$factarray["REFN"] = "Ссылка";
$factarray["RELI"] = "Вероисповедание";
$factarray["REPO"] = "Архив";
$factarray["RESI"] = "Место проживания";
$factarray["RESN"] = "Ограниченный доступ";
$factarray["RETI"] = "Отставка";
$factarray["RFN"] = "Номер записи в файле";
$factarray["RIN"] = "Индентификационный номер";
$factarray["ROLE"] = "Роль";
$factarray["SEX"] = "Пол";
$factarray["SLGC"] = "LDS Child Sealing";
$factarray["SLGS"] = "LDS Spouse Sealing";
$factarray["SOUR"] = "Источник";
$factarray["SPFX"] = "Префикс к фамилии";
$factarray["SSN"] = "Номер социального страхования";
$factarray["STAE"] = "Штат";
$factarray["STAT"] = "Статус";
$factarray["SUBM"] = "Податель";
$factarray["SUBN"] = "Подача";
$factarray["SURN"] = "Фамилия";
$factarray["TEMP"] = "Храм мормонов";
$factarray["TEXT"] = "Текст";
$factarray["TIME"] = "Время";
$factarray["TITL"] = "Заглавие";
$factarray["TRLR"] = "Конец файла";
$factarray["TYPE"] = "Вид";
$factarray["VERS"] = "Версия";
$factarray["WIFE"] = "Супруга";
$factarray["WILL"] = "Завещание";
$factarray["_AKA"] = "Иначе";
$factarray["_EMAIL"] = "Адрес электронной почты";
$factarray["_MARNM"] = "Фамилия в браке:";
$factarray["_TODO"] = "К исполнению";
$factarray["_UID"] = "Универсальный идентификатор";

// These facts are specific to gedcom exports from Family Tree Maker
$factarray["_MDCL"]	= "Medical";

// Other common customized facts
$factarray["_ADPF"]	= "Adopted by father";

if (file_exists($PGV_BASE_DIRECTORY . "languages/facts.ru.extra.php")) require $PGV_BASE_DIRECTORY . "languages/facts.ru.extra.php";

?>
